import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;

public class Nomad {

    private static String _dimensions	= "DIMENSION ";
    private static String _executable	= "\n BB_EXE ";
    private static String _poll_size	= "\n INITIAL_POLL_SIZE ";
    // Format for the starting point for n dimensions -> ( x_0 x_1 ... x_n ) 
    private static String _start_point	= "\n X0 ";
    // Format: * -100 -> means that all dimensions (*) have a lower bound of -100
    private static String _lower_bound	= "\n LOWER_BOUND ";
    private static String _upper_bound	= "\n UPPER_BOUND ";
    private static String _max_eval		= "\n MAX_BB_EVAL ";
    
    private static String _others		= "\n BB_OUTPUT_TYPE OBJ PB EB \n"
    									+ "DISPLAY_DEGREE 2 \n" + 
    									"DISPLAY_ALL_EVAL yes\n" + 
    									"DISPLAY_STATS BBE ( SOL ) OBJ 	";
    
	
	/**
	 * 
	 */
	public static double[] process(int dimensions, String executable, double poll_size, double start_point, double lower_bound, double upper_bound, long max_eval) {
		
		// We first create a file with all the necessary parameters for nomad
		prepearNomadFile(dimensions, executable, poll_size, start_point, lower_bound, upper_bound, max_eval);
	    
		// Then
		// Warning: Nomad must be installed in your machine
		//          See https://www.gerad.ca/nomad/
		Process p = Runtime.getRuntime().exec("nomad autoNomadParameters.txt");
	    p.waitFor();

	    BufferedReader reader = 
	         new BufferedReader(new InputStreamReader(p.getInputStream()));

	    String lastLine = "";

	    while ((String sCurrentLine = reader.readLine()) != null) 
	    {
	        System.out.println(sCurrentLine);
	        lastLine = sCurrentLine;
	    }
		
		return null;
	}
	
	private static void prepearNomadFile (int dimensions, String executable, double poll_size, double start_point, double lower_bound, double upper_bound, long max_eval) {
		//Prepearing the file autoNomadParameters.txt for NOMAD 
				String content = _dimensions + dimensions
						+ _executable + executable
						+ _poll_size + poll_size
						+ _start_point + start_point
						+ _lower_bound + lower_bound
						+ _upper_bound + upper_bound
						+ _max_eval + max_eval
						+ _others ;
				
				try {
					BufferedWriter writer = new BufferedWriter(new FileWriter("autoNomadParameters.txt"));
					writer.write(content);
				    writer.close();
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
	}
	
	
}
